import sys, random
from math import *

class Bayes:
  @staticmethod
  def normalize(text):
    return " ".join(map(lambda a : "".join(filter(lambda x : x.isalpha(), a)), text.lower().split())).strip()

  @staticmethod
  def readFile(filename):
    f = open(filename, encoding="utf-8")
    text = ""
    res = []
    for s in f.readlines():
      s = s.lower()
      if s.strip() == "":
        continue
      if s[0] != '\t':
        text = text.strip()
        if len(text) > 0:
          res.append(Bayes.normalize(text))
        text = ""
      else:
        text += s + " "
    return res

  def __init__(self, name):
    self.texts = Bayes.readFile(name)
    self.cnt = len(self.texts)
    self.count = {}
    self.learned = 0
    self.skipped = []
    for text in self.texts:
      if random.randint(1, 2) == 1:
        self.learned += 1
        for word in set(text.split()):
          self.count[word] = self.count.get(word, 0) + 1
      else:
        self.skipped.append(text)
    print("%d of %d (%d skipped)" % (self.learned, len(self.texts), len(self.skipped)))
    for word in self.count:
      Bayes.count[word] = Bayes.count.get(word, 0) + self.count[word]
        
  def probability(self, text):
    res = log(self.cnt)
    for word in Bayes.normalize(text).split():
      if len(word) <= 3: continue
      if Bayes.count.get(word, 0) > 30: continue
      cnt = max(self.count.get(word, 0), 0.5)
      res += log(cnt / self.cnt)
    return res

Bayes.count = {}
a = Bayes("a.txt")
b = Bayes("b.txt")

print(a.count["бурь"])
print(b.count["бурь"])
exit()

def who(c):
  pa = a.probability(c)
  pb = b.probability(c)
  #print("Пушкин" if pa > pb else "Лермонтов", pa - pb)
  return pa > pb

#who(" ".join(open("c.txt", encoding="utf-8").readlines()))
#exit()

def check(s, l, ans):
  errors = 0
  for t in l:
    if who(t) != ans:
      errors += 1
  print("%s: %d errros of %d queries, ratio = %.2f" % (s, errors, len(l), errors / len(l)))

check("Пушкин", a.skipped, True)
check("Лермонтов", b.skipped, False)
