#include <cstdio>

#include <algorithm>
#include <string>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
int orandseed;
void osrand( int s ) { orandseed = s; }
int orand() { return ((orandseed = orandseed * 239017 + 301703) >> 8) & 0x7FFF; }
int R( int a, int b ) { return ((orand() << 16) | orand()) % (b - a + 1) + a; }

void randomTest( int aLength, int bLength )
{
  forn (i, aLength)
    putc('0' + orand() % 4, stdout);
  puts("");
  forn (i, bLength)
    putc('0' + orand() % 4, stdout);
  puts("");
  puts("");
}

void outputMaximum( int length )
{
  string s = "";
  int i = 0;
  char c[] = "3300";
  while ((int)s.length() < length)
    s += c[i++], i %= 4;
  reverse(s.begin(), s.end());
  printf("%s\n", s.c_str());
}

void maximumTest( int aLength, int bLength )
{
  outputMaximum(aLength);
  outputMaximum(bLength);
  puts("");
}

#define MOD(X, M) (((X) % (M) + (M)) % (M))
#define DIV(X, M) (((X) - MOD((X), (M))) / (M))

void output( int x, int xi )
{
  string s = "";
  while (x != 0 || xi != 0)
  {
    s += '0' + MOD(x, 4);
    x = -DIV(x, 4);
    if (xi != 0 || x != 0)
    {
      s += '0' + MOD(xi, 4);
      xi = -DIV(xi, 4);
    }
  }
  reverse(s.begin(), s.end());
  printf("%s\n", s.c_str());
}

void fixedTest( int a, int ai, int b, int bi )
{
  output(a, ai);
  output(b, bi);
  puts("");
}

void growTests( int aLength, int bLength )
{
  if (aLength > 1000000 || bLength > 1000000)
    return;
  randomTest(aLength, bLength);
  maximumTest(aLength, bLength);
  forn (i, 2)
    growTests(aLength * (orand() % 100 + 10), bLength * (orand() % 100 + 10));
}

int main()
{
  osrand(170239);
  for (int a = -1; a <= 1; a++)
    for (int ai = -1; ai <= 1; ai++)
      for (int b = -1; b <= 1; b++)
        for (int bi = -1; bi <= 1; bi++)
          fixedTest(a, ai, b, bi);
  forn (i, 20)
    fixedTest(R(-100, 100), R(-100, 100), R(-100, 100), R(-100, 100));
  growTests(10, 10);
  forn (i, 5)
    randomTest(1000000, 1000000);
  maximumTest(1000000, 1000000);
  return 0;
}

