#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>

using namespace std;

#define MAX 300
int n, m;
char b[MAX][MAX];
char names[][10] = {"TRIANGLE", "SQUARE", "PENTAGON"};


#define MP 4000
int x[MP], y[MP];
double calcDiameter() {
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (b[i][j] == '#') {
				x[cnt] = j;
				y[cnt] = i;
				cnt++;
			}
		}
	}
	int D2 = 0;
	for (int i = 0; i < cnt; i++) {
		for (int j = 0; j < i; j++) {
			D2 = max(D2, (x[i] - x[j] + 1) * (x[i] - x[j] + 1) + (y[i] - y[j] + 1) * (y[i] - y[j] + 1));
		}
	}
	return sqrt(D2);
}


int calcArea() {
	int area = 0;
	for (int i = 0; i < n; i++) {
		int x1 = MAX, x2 = -1;
		for (int j = 0; j < m; j++) {
			if (b[i][j] == '#') {
				x1 = min(x1, j);
				x2 = max(x2, j);	
			}
		}
		if (x1 <= x2) {
			area += x2 - x1 + 1;
		}
	} 	
	return area;
}

double ratio[10];
void calcRatio() {
	for (int k = 3; k <= 5; k++) {
		double diam2 = 2 * (1 - cos(2 * M_PI * (k / 2) / k));
		double area = k * sin(2 * M_PI / k) / 2;
		ratio[k] = diam2 / area;
	}
}

#define NAME "captcha"

int main() {
	assert(freopen(NAME ".in", "r", stdin));
  	assert(freopen(NAME ".out", "w", stdout));

      scanf("%d %d", &n, &m);
      for (int i = 0; i < n; i++) {
      	scanf("%s", &b[i]);
      } 

      double diam = calcDiameter(), area = calcArea(), myRatio = diam * diam / area;
	calcRatio();

	int bestK = 3;                       
	for (int k = 4; k <= 5; k++) {
		if (abs(1 - myRatio / ratio[k]) < abs(1 - myRatio / ratio[bestK])) {
			bestK = k;
		}
	}
	printf("%s\n", names[bestK - 3]);
	return 0;
}
