import java.util.*;
import java.io.*;
import java.math.BigInteger;
import static java.lang.Math.*;

public class captcha_rb_dist implements Runnable {

	final String [] names = new String [] {"TRIANGLE", "SQUARE", "PENTAGON"};
	//       ( ,   AB)
	//    (AC + BC)
	final double [] ratio = new double [] {0.5, 1 / sqrt(2), 2 * cos(PI / 5) / (2 * cos(PI / 5) + 1)};

	void solve() throws Exception {
		int n = nextInt(), m = nextInt();
		char [][] b = new char[n][];
		for (int i = 0; i < n; i++) {
			b[i] = in.readLine().toCharArray();
		}

		ArrayList <P> pts = new ArrayList <P> ();
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (b[i][j] == '#') {
					pts.add(new P(j, i));
				}
			}
		}

		P [] arr = pts.toArray(new P[0]);
		int filled = arr.length, first = 0, second = 0;
		double maxDist = 0;
		for (int i = 0; i < filled; i++) {
			for (int j = 0; j < i; j++) {
				double curDist = P.dist(arr[i], arr[j]);
				if (curDist > maxDist) {
					maxDist = curDist;
					first = i;
					second = j;
				}
			}	
		}

		double sumDist = 0;
		for (int i = 0; i < filled; i++) {
			double curDist = P.dist(arr[first], arr[i]) + P.dist(arr[second], arr[i]);
			if (curDist > sumDist) {
				sumDist = curDist;
			}
		}

		double myRatio = maxDist / sumDist;
		int bestK = 0;
		for (int i = 1; i < 3; i++) {
			if (abs(ratio[i] - myRatio) < abs(ratio[bestK] - myRatio)) {
			 	bestK = i;
			}
		}
		out.println(names[bestK]);
	}

	public static void main(String[] args) {
		new Thread(new captcha_rb_dist()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			String problemName = "captcha";
			in = new BufferedReader(new FileReader(problemName + ".in"));
			out = new PrintStream(problemName + ".out");
			solve();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	StringTokenizer tokenizer = new StringTokenizer("");
	BufferedReader in;
	PrintStream out;

	boolean seekForToken() {
		while (!tokenizer.hasMoreTokens()) {
			String s = null;
			try {
				s = in.readLine();
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (s == null)
				return false;
			tokenizer = new StringTokenizer(s);
		}
		return true;
	}

	String nextToken() {
		return seekForToken() ? tokenizer.nextToken() : null;
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	static class P {
      	double x, y;
      	P(double x, double y) { this.x = x; this.y = y; }
      	P subtract(P r) { return new P(x - r.x, y - r.y); }
      	double length() { return hypot(x, y); }
      	static double dist(P p1, P p2) { return p1.subtract(p2).length(); }
	}
}
