import java.util.*;
import java.io.*;
import java.math.BigInteger;
import static java.lang.Math.*;

public class captcha_rb_pivots implements Runnable {

	final int MAX_FILLED = 4000;
	final String [] names = new String [] {"TRIANGLE", "SQUARE", "PENTAGON"};

	void solve() throws Exception {
		int n = nextInt(), m = nextInt();
		char [][] b = new char[n][];
		for (int i = 0; i < n; i++) {
			b[i] = in.readLine().toCharArray();
		}

		int filled = 0;
		int [] x = new int[MAX_FILLED];
		int [] y = new int[MAX_FILLED];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (b[i][j] == '#') {
					x[filled] = j;
					y[filled] = i;
					filled++;
				}
			}
		}

		int [][] count = new int[n][m];
		for (int it = 0; it < 180; it++) {
			double fi = it / PI, c1 = cos(fi), c2 = sin(fi);
			int minX = x[0], minY = y[0], maxX = x[0], maxY = y[0];
			for (int i = 0; i < filled; i++) {
				double minVal = c1 * minX + c2 * minY;		
				double maxVal = c1 * maxX + c2 * maxY;		
				double ourVal = c1 * x[i] + c2 * y[i];
				if (ourVal < minVal) {
					minX = x[i];
					minY= y[i];
				}		
				if (ourVal > maxVal) {
					maxX = x[i];
					maxY = y[i];
				}
			}
			count[minY][minX]++;
			count[maxY][maxX]++;	
		}


		ArrayList <P> pivots = new ArrayList <P> ();
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (count[i][j] > 15) {
					pivots.add(new P(j, i));
				}
			}
		}

		int vertices = 0;
		for (int i = 0; i < pivots.size(); i++) {
			boolean good = true;
			for (int j = 0; j < i; j++) {
				if (P.dist(pivots.get(i), pivots.get(j)) < 20) {
					good = false;
				}
			}	
			if (good) vertices++;
		}

		out.println(names[vertices - 3]);
		out.close();
	}

	public static void main(String[] args) {
		new Thread(new captcha_rb_pivots()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			String problemName = "captcha";
			in = new BufferedReader(new FileReader(problemName + ".in"));
			out = new PrintWriter(problemName + ".out");
			solve();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	StringTokenizer tokenizer = new StringTokenizer("");
	BufferedReader in;
	PrintWriter out;

	boolean seekForToken() {
		while (!tokenizer.hasMoreTokens()) {
			String s = null;
			try {
				s = in.readLine();
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (s == null)
				return false;
			tokenizer = new StringTokenizer(s);
		}
		return true;
	}

	String nextToken() {
		return seekForToken() ? tokenizer.nextToken() : null;
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	static class P {
      	double x, y;
      	P(double x, double y) { this.x = x; this.y = y; }
      	P subtract(P r) { return new P(x - r.x, y - r.y); }
      	double length() { return hypot(x, y); }
      	static double dist(P p1, P p2) { return p1.subtract(p2).length(); }
	}
}
