{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
uses SysUtils, Math;

type TRational = record
  a,b : int64;
  end;
const MAX_N = 5;
      MAX_R = 100;
function gcd(a,b:int64):int64;
var c:int64;
begin
if a < b then begin c:=a;a:=b;b:=c;end;
while b<>0 do begin c:=a mod b;a:=b;b:=c;end;
Result := a;
end;
procedure canonical(var this:TRational);
var g:int64;
begin
g := gcd(this.a,this.b);
this.a := this.a div g;
this.b := this.b div g;
end;
procedure print(var this:TRational);
begin
canonical(this);
Writeln(this.a,'/',this.b);
end;

procedure err(s:string);
begin
Writeln(s);flush(output);
halt(1);
end;
function init(a,b:int64):TRational;
begin
if (a < 0) then err('Rational(negative a)');
if (b <= 0) then err('Rational(not posiive b)');
Result.a := a;Result.b := b;
end;
function add(const this,y:TRational):TRational;
var g:int64;
begin
g := gcd(this.b,y.b);
Result := init(this.a * (y.b div g) + y.a * (this.b div g), (this.b div g) * y.b);
canonical(Result);
end;
function diff(const this,y:TRational):TRational;
var g:int64;
begin
g := gcd(this.b,y.b);
Result := init(abs(this.a * (y.b div g) - y.a * (this.b div g)), (this.b div g) * y.b);
canonical(Result);
end;
function multiply(const this,y:TRational):TRational;
var g1,g2:int64;
begin
g1 := gcd(this.a, y.b);g2 := gcd(y.a, this.b);
Result := init((this.a div g1) * (y.a div g2),  (this.b div g2) * (y.b div g1));
end;
function divide(const this,y:TRational):TRational;
var r : TRational;
begin
r := init(y.b,y.a);
Result := multiply(this,r);
end;
function compareTo(const this,y:TRational) : integer;
var g,x1,x2:int64;
    f1,f2: extended;
//  z:TRational;
begin
//z := this;print(z);z := y;print(z);flush(output);

g := gcd(this.b,y.b);

f1 := this.a;f1 := f1 * (y.b div g);
f2 := y.a;f2 := f2 * (this.b div g);
if abs(f1-f2) > max(1e-10, 1e-10 * max(f1,f2)) then
  begin
  if (f1 < f2) then begin Result := -1;exit;end;
  if (f1 > f2) then begin Result :=  1;exit;end;
  err('?????');
  end;

x1 := this.a * (y.b div g);
x2 := y.a * (this.b div g);
if (x1 < x2) then begin Result := -1;exit;end;
if (x1 > x2) then begin Result :=  1;exit;end;
Result := 0;
end;

procedure readr (var x:integer; a, b:integer);
begin
  assert (not seekeoln); read (x); assert ((a<=x) and (x<=b));
end;

procedure readl;
var c:char;
begin
  {$IFNDEF LINUX}
  read (c); assert (c=#13);
  {$ENDIF}
  read (c); assert (c=#10);
end;
var r,min_err : TRational;
    a : array[0..2*MAX_N] of TRational;
    N : integer;
procedure update(const x:TRational);
var err:TRational;
begin
err := diff(x,r);
if compareTo(min_err, err) > 0 then min_err := err;
end;
procedure go(st,depth:integer);
var z:TRational;
    i,j:integer;
begin
for i:=0 to depth-1 do if 0 <> (st and (1 shl i)) then
  for j:=i+1 to depth-1 do if 0 <> (st and (1 shl j)) then
    begin
    a[depth] := add(a[i],a[j]);
    update(a[depth]);
    go(st - (1 shl i) - (1 shl j), depth + 1);
    z := multiply(a[i],a[j]);
    a[depth] := divide(z, a[depth]);
    update(a[depth]);
    go(st - (1 shl i) - (1 shl j), depth + 1);
    end;
end;
var i,ra,rb,sum_r:integer;
begin
Assign(input,'circuit.in');Reset(input);
Assign(output,'circuit.out');Rewrite(output);
readr(N, 1, 5); readr(ra, 0, maxlongint); readr(rb, 1, 100);readl;r := init(ra,rb);
sum_r := 0;
for i:=0 to N-1 do begin readr(ra, 1, 100);a[i] := init(ra,1);inc(sum_r,ra); end;readl;
Close(input);
min_err := init(sum_r, 1);
if (compareTo(r, min_err) > 0) then err('R > ' + IntToStr(sum_r));
for i:=0 to N-1 do update(a[i]);
go($7fffffff,N);
print(min_err);
Close(output);
end.
