import java.util.*;
import java.io.*;
import java.math.BigInteger;

public class circuit_am
  {
  static final String filename = "circuit";
  static BufferedReader in;
  static PrintStream out;
  static final int MAX_N = 5;
  static final int MAX_R = 100;
  static final int DBG = 0;
  static int N;
  static Rational r;
  static Rational a[];
  static Rational min_err;

  static BigInteger max_amplitude = BigInteger.ZERO;
  static class Rational implements Comparable<Rational>
  {
  BigInteger a,b;
  Rational (BigInteger a, BigInteger b)
  {
  if (max_amplitude.compareTo(a) < 0) max_amplitude = a;
  if (max_amplitude.compareTo(b) < 0) max_amplitude = b;
  this.a = a;this.b = b;
  }
  Rational (long a, long b) {this.a = BigInteger.valueOf(a);this.b = BigInteger.valueOf(b);}
  Rational add(Rational y)
  {
  return new Rational(this.a.multiply(y.b).add(y.a.multiply(this.b) ), this.b.multiply(y.b) );
  }
  Rational diff(Rational y)
  {
  return new Rational(this.a.multiply(y.b).subtract(y.a.multiply(this.b)).abs(), this.b.multiply(y.b) );
  }
  Rational multiply(Rational y)
  {
  return new Rational(this.a.multiply(y.a), this.b.multiply(y.b));
  }
  Rational divide(Rational y)
  {
  return new Rational(this.a.multiply(y.b), this.b.multiply(y.a));
  }

  public int compareTo(Rational y)
  {
  return this.a.multiply(y.b).compareTo(y.a.multiply(this.b));
  }
  void canonical()
  {
  BigInteger g = a.gcd(b);
  a = a.divide(g);
  b = b.divide(g);
  }
  @Override
  public String toString() {canonical();return a + "/" + b;}
  }
  static void update(Rational x)
  {
  Rational err = x.diff(r);
  if (min_err.compareTo(err) > 0) min_err = err;
  }
  static void go(int st,int depth)
  {
  for(int i=0;i<depth;++i) if (0 != (st & (1<<i)))
    for(int j=i+1;j<depth;++j) if (0 != (st & (1<<j)))
      {
      update(a[depth] = a[i].add(a[j]));
      go(st - (1<<i) - (1<<j),depth+1);
      update(a[depth] = a[i].multiply(a[j]).divide(a[depth]));
      go(st - (1<<i) - (1<<j),depth+1);
      }
  }
  static long gcd(long a,long b)
  {
  return BigInteger.valueOf(a).gcd(BigInteger.valueOf(b)).longValue();
  }

  static void test() throws IOException
  {
  int z[] = readIntegersSeparatedByOneSpace(3),i,j,k;
  if (z[1] < 0 || z[2] < 0) throw new Error("negative integers in input");
  if (gcd(z[1],z[2]) != 1) throw new Error("a,b isn't coprime");
  r = new Rational(z[1],z[2]);
  N = z[0];
  if (N < 1 || N > MAX_N) throw new Error("N = " + N + " - out of range");
  a = new Rational[2*N-1];
  z = readIntegersSeparatedByOneSpace(N);
  int sum_r = 0;
  for(i=0;i<N;++i)
    {
    if (z[i] < 1 || z[i] > MAX_R)
      throw new Error("R[" + (i+1) + "] = " + z[i] + " - out of range");
    a[i] = new Rational(z[i],1);
    sum_r += z[i];
    }
  min_err = new Rational(sum_r,1);
  if (r.compareTo(min_err) > 0)
   throw new Error(r + " > " + sum_r);
  for(i=0;i<N;++i) update(a[i]);

  go(0x7fffffff,N);
  out.println(min_err);

  if (min_err.a.compareTo(BigInteger.valueOf(Long.MAX_VALUE))>0 ||
      min_err.b.compareTo(BigInteger.valueOf(Long.MAX_VALUE))>0)
    throw new Error("ans = " + min_err + " - long overflow");

  //out.println(max_amplitude );
  }
  public static void main (String[] argv) throws IOException
  {
  in = new BufferedReader(new InputStreamReader(new FileInputStream(filename+ ".in")));
  out = new PrintStream(new BufferedOutputStream(new FileOutputStream(filename + ".out")));
  test();
  if (in.readLine()!=null) throw new Error("eof expected");
  in.close();
  out.close();
  }
static int line;
static int[] readIntegersSeparatedByOneSpace(int alength) throws IOException
  {
  int r[] = new int[alength],k=0;
  for(String s : readTokensSeparatedByOneSpace(alength)) r[k++] = Integer.parseInt(s);
  return r;
  }
static String sline() {return "line #" + line + ": ";}
static List<String> readTokensSeparatedByOneSpace(int alength) throws IOException
  {
  int i;
  ++line;
  StringTokenizer st = new StringTokenizer(in.readLine()," ",true);
  Vector<String> v = new Vector<String>();
  for(i=0;;i++)
    {
    if (!st.hasMoreTokens()) break;
    String s = st.nextToken();
    if (0 == (i & 1)) v.add(s);
    else if (!s.equals(" "))
      throw new RuntimeException(sline() + "single space expected, but " + s + " found");
    }
  if (0 == (i & 1))
    throw new RuntimeException(sline() + "input line ended by whitespace");
  if (alength >= 0 && v.size() != alength)
    throw new RuntimeException(sline() +  "number of tokens != " + alength);
  return v;
  }
}
