import java.util.*;
import java.io.*;

public class circuit_am_long
  {
  static final String filename = "circuit";
  static BufferedReader in;
  static PrintStream out;
  static final int MAX_N = 5;
  static final int MAX_R = 100;
  static final int DBG = 0;
  static int N;
  static Rational r;
  static Rational a[];
  static Rational min_err;

  static long max_amplitude = 0L;
  static long gcd(long a,long b)
  {
  if (a < b) {long c = a;a = b;b = c;}
  while(b != 0) {long c = a % b;a = b;b = c;}
  return a;
  }

  static class Rational implements Comparable<Rational>
  {
  long a,b;
  Rational (long a, long b)
  {
  if (a < 0) throw new Error("Rational(negative a)");
  if (b <= 0) throw new Error("Rational(not posiive b)");
  if (max_amplitude<a ) max_amplitude = a;
  if (max_amplitude<b ) max_amplitude = b;
  this.a = a;this.b = b;
  }
  Rational add(Rational y)
  {
  long g = gcd(this.b,y.b);
  Rational r = new Rational(this.a * (y.b / g) + y.a * (this.b /  g), (this.b / g) * y.b);
  r.canonical();
  return r;
  }
  Rational diff(Rational y)
  {
  long g = gcd(this.b,y.b);
  Rational r = new Rational(Math.abs(this.a * (y.b / g) - y.a * (this.b /  g)), (this.b / g) * y.b);
  r.canonical();
  return r;
  }
  Rational multiply(Rational y)
  {
  long g1 = gcd(this.a, y.b),g2 = gcd(y.a, this.b);
  Rational r = new Rational((this.a / g1) * (y.a / g2),  (this.b / g2) * (y.b / g1));
  return r;
  }
  Rational divide(Rational y)
  {
  Rational r = new Rational(y.b,y.a);
  return multiply(r);
  }

  public int compareTo(Rational y)
  {
  long z1 = this.a / this.b;
  long z2 = y.a / y.b;
  if (z1 < z2) return -1;
  if (z1 > z2) return  1;
  long g = gcd(this.b,y.b);
  long x1 = (this.a % this.b) * (y.b / g);
  long x2 = (y.a % y.b) * (this.b /  g);
  if (x1 < x2) return -1;
  if (x1 > x2) return 1;
  return 0;
  }

  void canonical()
  {
  long g = gcd(a,b);
  a /= g;
  b /= g;
  }
  @Override
  public String toString() {canonical();return a + "/" + b;}
  }
  static void update(Rational x)
  {
  Rational err = x.diff(r);
  if (min_err.compareTo(err) > 0) min_err = err;
  }
  static void go(int st,int depth)
  {
  for(int i=0;i<depth;++i) if (0 != (st & (1<<i)))
    for(int j=i+1;j<depth;++j) if (0 != (st & (1<<j)))
      {
      update(a[depth] = a[i].add(a[j]));
      go(st - (1<<i) - (1<<j),depth+1);
      update(a[depth] = a[i].multiply(a[j]).divide(a[depth]));
      go(st - (1<<i) - (1<<j),depth+1);
      }
  }

  static void test() throws IOException
  {
  int z[] = readIntegersSeparatedByOneSpace(3),i,j,k;
  if (z[1] < 0 || z[2] < 0) throw new Error("negative integers in input");
  if (gcd(z[1],z[2]) != 1) throw new Error("a,b isn't coprime");
  r = new Rational(z[1],z[2]);
  N = z[0];
  if (N < 1 || N > MAX_N) throw new Error("N = " + N + " - out of range");
  a = new Rational[2*N-1];
  z = readIntegersSeparatedByOneSpace(N);
  int sum_r = 0;
  for(i=0;i<N;++i)
    {
    if (z[i] < 1 || z[i] > MAX_R)
      throw new Error("R[" + (i+1) + "] = " + z[i] + " - out of range");
    a[i] = new Rational(z[i],1);
    sum_r += z[i];
    }
  min_err = new Rational(sum_r,1);
  if (r.compareTo(min_err) > 0)
   throw new Error(r + " > " + sum_r);
  for(i=0;i<N;++i) update(a[i]);

  go(0x7fffffff,N);
  out.println(min_err);

  //out.println(max_amplitude );
  }
  public static void main (String[] argv) throws IOException
  {
  in = new BufferedReader(new InputStreamReader(new FileInputStream(filename+ ".in")));
  out = new PrintStream(new BufferedOutputStream(new FileOutputStream(filename + ".out")));
  test();
  if (in.readLine()!=null) throw new Error("eof expected");
  in.close();
  out.close();
  }
static int line;
static int[] readIntegersSeparatedByOneSpace(int alength) throws IOException
  {
  int r[] = new int[alength],k=0;
  for(String s : readTokensSeparatedByOneSpace(alength)) r[k++] = Integer.parseInt(s);
  return r;
  }
static String sline() {return "line #" + line + ": ";}
static List<String> readTokensSeparatedByOneSpace(int alength) throws IOException
  {
  int i;
  ++line;
  StringTokenizer st = new StringTokenizer(in.readLine()," ",true);
  Vector<String> v = new Vector<String>();
  for(i=0;;i++)
    {
    if (!st.hasMoreTokens()) break;
    String s = st.nextToken();
    if (0 == (i & 1)) v.add(s);
    else if (!s.equals(" "))
      throw new RuntimeException(sline() + "single space expected, but " + s + " found");
    }
  if (0 == (i & 1))
    throw new RuntimeException(sline() + "input line ended by whitespace");
  if (alength >= 0 && v.size() != alength)
    throw new RuntimeException(sline() +  "number of tokens != " + alength);
  return v;
  }
}
