#include <algorithm>
#include <cstdio>
#include <cassert>
#include <string>
#include <iostream>
#include <cmath>
#include <set>

using namespace std;  

#define forit(i,s) for(__typeof(s.begin()) i = s.begin(); i != s.end(); i++)

long long mabs( long long x ){return x < 0 ? -x : x;}
struct num
{
  long long a, b;
  void upd(){long long t = __gcd(a, b); a /= t, b /= t; if (b < 0) a = -a, b = -b;}
  num( long long _a = 0, long long _b = 1){a = _a, b = _b, upd();}
  const num inv() {return num(b, a);}
  const num abs() {return num(mabs(a), mabs(b));}
  int sg(){return a > 0 ? +1 : a < 0 ? -1 : 0;}
};
num operator + (num a, num b){return num(a.a * b.b + a.b * b.a, a.b * b.b);}
num operator - (num a, num b){return num(a.a * b.b - a.b * b.a, a.b * b.b);}
bool operator < (num a, num b){return (a - b).a < 0;}
bool operator == (num a, num b){return a.a == b.a && a.b == b.b;}

void myassert( bool f, string s )
{
  if (!f)
  {
    cout << s << endl;
    exit(1);
  }
}

int n, a, b, r[5];
set <num> v[1 << 5];


void out( FILE *f, num x )
{
  fprintf(stderr, "%lld/%lld\n", x.a, x.b);
}

int main( void )
{
  freopen("circuit.in", "r", stdin);
  freopen("circuit.out", "w", stdout);
  scanf("%d%d%d", &n, &a, &b);
  myassert(1 <= n && n <= 5, "1 <= n && n <= 5");
  int sum = 0;
  for (int i = 0; i < n; i++)
  {
    scanf("%d", &r[i]);
    myassert(1 <= r[i] && r[i] <= 100, "1 <= R_i && R_i <= 100");
    sum += r[i];
  }
  myassert(__gcd(a, b) == 1, "gcd(a, b) == 1");
  myassert(sum * b >= a, "R <= sum(R_i)");
  myassert(a >= 0, "R >= 0");

  for (int i = 0; i < n; i++)  
    v[1 << i].insert(num(r[i]));
  for (int i = 1; i < (1 << n); i++)
    for (int a = (i - 1) & i; a > 0; a = (a - 1) & i)
    {
      int b = i ^ a;
      forit(x, v[a]) forit(y, v[b])
      {
        num a = *x, b = *y;
        v[i].insert(a + b);
        v[i].insert((a.inv() + b.inv()).inv());
      }
    }

  num need(a, b), res(0xffff, b), ans;

  bool was = true;
  for (int i = 0; i < (1 << n); i++)
    forit(x, v[i])
    {
      num curr = *x - need;
      if (was == false || curr.abs() < res.abs() || curr.abs() == res.abs() && curr < res)
        res = curr, ans = *x, was = true;
    }
  cout << res.abs().a << "/" << res.abs().b;

  return 0;
}
