@echo off
call include.cmd
if exist tests (
 pushd tests
 set RELPATH=..
) else (
 set RELPATH=.
)
if exist doall.py (
 doall.py
)
echo Compiling solution and checker...
if exist %RELPATH%\%SOL%.cpp (
 g++ -O2 -Wall -Wl,--stack=67108864 %RELPATH%\%SOL%.cpp -o %SOL%.exe
) else if exist %RELPATH%\%SOL%.c (
 gcc -x c -O2 -Wall -Wl,--stack=67108864 %RELPATH%\%SOL%.c -o %SOL%.exe
) else if exist %RELPATH%\%SOL%.pas (
 fpc -FE. %RELPATH%\%SOL%
) else if exist %RELPATH%\%SOL%.dpr (
 dcc32 -cc -e. %RELPATH%\%SOL%
) else if exist %RELPATH%\%SOL%.java (
 javac -d . %RELPATH%\%SOL%.java
)
if exist %RELPATH%\check.cpp (
 g++ -O2 -Wall -Wl,--stack=67108864 %RELPATH%\check.cpp -o %RELPATH%\check.exe
) else if exist %RELPATH%\check.dpr (
 dcc32 -cc %RELPATH%\check.dpr -e%RELPATH% -I%TESTLIB% -U%TESTLIB%
) else (
 echo Can not compile checker!
)
echo Processing solution %SOL% on tests...
for %%t in (??) do (
 echo Test %%t
 copy %%t %TASK%.in >nul
 if exist %SOL%.class (
  java -Xmx256M -Xss64m -ea %SOL%
 ) else (
  %SOL%
 )
 move %TASK%.out %%t.a >nul
)
if exist %SOL%.exe erase %SOL%.exe
if exist %SOL%.class erase %SOL%.class
if %RELPATH%==.. (
 popd
)
echo Done!
