#!/usr/bin/env python2

from amtest import *

MAX_N = 5
MAX_R = 100
MAX_V = 100

def pt(z,desc=''):
  u,v,r = z
  g = Math.gcd(u,v)
  u /= g
  v /= g

  assert(1 <= v <= MAX_V)
  assert(0 <= u <= v * sum(r))
  assert(min(r) > 0)
  assert(max(r) <= MAX_R)
  assert(1 <= len(r) <= MAX_N)

  f.begin_test(desc)
  f.write('%d %d %d\n' % (len(r),u,v))
  f.write(' '.join(list(map(str,r))) + '\n')
  f.end_test()


def rt(n,r=None):
  if r==None:
    r = [random.randint(1,MAX_R) for i in range(n)]
  b = random.randint(1,MAX_V)
  a = random.randint(0,b * sum(r))
  pt( (a,b,r) )

def sample():
  pt((2,3,[1,2]))
  pt((3,2,[1,2]))


def small():
  pt( (1,1,[1]) )
  pt( (1,2,[1]) )
  for n in range(2,MAX_N):
    for o in range(3):
      rt(n)

def big():
  pt((0,1,[1]*MAX_N))
  pt((100*MAX_R*MAX_N-1,100,[MAX_R]*MAX_N))
  p = [73, 79, 83, 89, 97]

  pt( (475, 97, p) )
  pt( (39092, 99, p) )

  for t in range(20):
    rt(MAX_N)
  for t in range(10):
    rt(MAX_N,p)

  r = range(MAX_R,MAX_R-MAX_N,-1)
  pt((sum(r) * 100 - 1,100,r) )

  pt((14, 78, [34, 50, 97, 63, 52]) )
  pt((31710, 76, [86, 97, 83, 87, 100]))

  pt ((653, 92, [82, 87, 95, 83, 99]))
  pt ( (37678, 85, [97, 99, 99, 98, 87]))

  pt ( (1,100, [89,95,97,98,99]) )

  pt ( (10203, 83, [89,95,97,98,99]) )

def main():
  global f
  f = TestGen(1,problem='circuit', tests_path=os.path.join('..','tests'))  
  sample()
  small()
  big()
  f.close()

if __name__ == '__main__': main()
