function die {
  echo $*
  exit 1
}


echo "compiling solution"
pushd ../solutions
  g++ -Wall -Wextra -Werror -O2 -o $1.exe $1.cpp || die "can't compile solution $1"
  cp $1.exe ../tests/$1.exe
popd

echo "compiling checker"
pushd ..
  g++ -Wall -Werror -Wextra -O2 check.cpp -o check.exe || die "can't compile $1"
  cp ./check.exe ./tests/check.exe
popd

TIMEFORMAT=%R

pushd ../tests
  ulimit -t 5 $1.exe
  for i in ?? ;do
     echo "runing on test $i"
     cp $i cnk.in
     time ./$1.exe || die "solution failed on $i"
     ./check.exe $i cnk.out $i.a || die "wa on test $i"
  done
popd

echo "removing temporary files"
rm ../tests/move.in
rm ../tests/move.out
rm ../tests/*.exe