function die {
  echo $*
  exit 1
}

problemname=cnk
sol=${problemname}_vs
echo $sol



#echo "Compilng gen.cpp"
#g++ -Wall -Werror -Wextra -O2 gen.cpp -o gen.exe || die "can't compile gen.cpp"
echo "Compilng validate.cpp"
g++ -Wall -Werror -Wextra -O2 validate.cpp -o validate.exe || die "can't compile gen.cpp"

rm -r ../tests
mkdir ../tests

echo Generating tests
#./gen.exe || die "generator failed"
python ./split.py || die "splitter failed"

cp validate.exe ../tests

pushd ../tests
  for i in ?? ; do
    echo "validating $i"
    ./validate.exe <$i || die "validation failed"
  done

  echo "generating answers"

  echo "compiling solution $sol"
  pushd ../solutions
    g++ -Wall -Werror -Wextra -O2 $sol.cpp -o $sol.exe || die "can't compile $sol"
  popd

  echo "compiling checker"
  pushd ..
    g++ -Wall -Werror -Wextra -O2 check.cpp -o check.exe || die "can't compile $sol"
  popd

  cp ../check.exe ./check.exe
  cp ../solutions/$sol.exe ./$sol.exe

  for i in ?? ; do
    echo "generating answer for $i"
    cp $i $problemname.in
    ./$sol.exe || die "solution failed"
    ./check.exe $problemname.in $problemname.out $problemname.out || die "check failed"
    cp $problemname.out $i.a
  done

popd

echo "removing temporary files"
rm ../solutions/$sol.exe
rm ../tests/$problemname.in
rm ../tests/$problemname.out
rm ../tests/*.exe
rm ./*.exe
