#!/usr/bin/env python2

from amtest import *

MAX_N = 500

def pt(z,desc=''):
  M = len(z)
  b = list(map(len, z))
  N = min(b)
  desc += ' M = %d, N = %d' % (M,N)
  assert(N == max(b))
  f.begin_test(desc)
  f.write('%d %d\n' % (M,N))
  for s in z: f.write(s + '\n')
  f.end_test()

def cvt(m,n,a):
  z = []
  for j in range(m):
    s = ''
    for i in range(n): s += a[j][i]
    z.append(s)
  return z

def rt(m,n,alphabet_size=26, ninsertions=0, minr = 1, maxr = MAX_N, possible_outside = 1):
  o = possible_outside #possibility insert diamond which doesn't fits in rectangle
  desc = 'rt(as = %d, ins = %d, minr = %d, maxr = %d)' % (alphabet_size,ninsertions,minr,maxr)
  assert(1 <= alphabet_size <= 26)
  z = [Str.random(n,string.ascii_uppercase[:alphabet_size]) for j in range(m)]
  maxr = min(maxr,(min(m,n)-1) >> 1)
  if (ninsertions>0) and (maxr>=minr):
    a = Matrix.make(m,n)
    for j in range(m):
      for i in range(n):
        a[j][i] = z[j][i]
    rr = [random.randint(minr,maxr) for k in range(ninsertions)]
    rr.sort()
    for k in range(ninsertions):
      r = rr[k]
      xc = random.randint(r-o,n-1-r+o)
      yc = random.randint(r-o,m-1-r+o)
      ch = a[yc][xc]
      for j in range(yc-r,yc+r+1):
        if (j>=0) and (j<m):
          for i in range(xc-(r-abs(yc-j)),xc+1+(r-abs(yc-j))):
            if (i>=0) and (i<n):
              a[j][i] = ch
    z = cvt(m,n,a)

  pt(z,desc)

def pattern(m,n,v,divisor,modulus,_as):
  a = Matrix.make(m,n)
  for j in range(m):
    for i in range(n):
      k = 0
      for xc,yc in v:
        k += abs(j-yc)+abs(i-xc)
        k = ((k // divisor) % modulus) % _as
        a[j][i] = chr(ord('A') + k)
  pt(cvt(m,n,a) )


def sample():
  pt(['ABAAA'] + (['AAAAA'] * 3))

def small():
  a = Matrix.make(3,3,default='A')
  for x,y in [(0,1),(1,0),(1,2),(2,1)]:
    a[y][x] = 'B'
    pt(cvt(3,3,a))
    a[y][x] = 'A'

  a = []
  a.append('AAAAA')
  a.append('AAAAA')
  a.append('AAAAA')
  a.append('ABBBA')
  a.append('AABAA')
  pt(a)

  a = []
  a.append('BBBBB')
  a.append('AAAAA')
  a.append('BBBBB')
  a.append('AAAAA')
  a.append('BBBBB')
  pt(a)

  rt(1,1,1)
  rt(1,10,2)
  rt(10,1,2)
  rt(5,5,1)
  r = [5,10,15]
  c = [(5,4),(4,5)] + [(x,y) for x in r for y in r] + [(n,n) for n in [20,50,100,150,200,300,400]]
  c.sort(key = lambda x:x[0]*x[1])
  for m,n in c:
    if (m <= MAX_N) and (n <= MAX_N):
      rt(m,n,2)
      rt(m,n,3,1,possible_outside=0)
      rt(m,n,4,2,possible_outside=0)

def big():
  rt(MAX_N,MAX_N,2, 2, MAX_N//4,MAX_N//4+1)
  rt(MAX_N,MAX_N,2, 1, MAX_N//2-1,MAX_N//2-1, possible_outside=0)
  rt(MAX_N,MAX_N,26, 10, 10, 11)
  rt(MAX_N,MAX_N,26, 100, 3, 3)
  rt(MAX_N,MAX_N,26, 100, 3, 10)
  for _as in [1,2,3]:
    rt(MAX_N,MAX_N,_as)
  for ins in range(1,10,2):
    rt(MAX_N,MAX_N,26, ins, minr=1, maxr=MAX_N//3)

  pattern(MAX_N,MAX_N, [((MAX_N>>1),(MAX_N>>1))],1,2,2)
  pattern(MAX_N,MAX_N, [((MAX_N>>1),(MAX_N>>1))],10,2,2)
  pattern(MAX_N,MAX_N, [((MAX_N>>1),(MAX_N>>1))],(MAX_N>>1)-1,2,2)
  for t in range(1,4):
    pattern(MAX_N,MAX_N, [(random.randrange(MAX_N),random.randrange(MAX_N)) for k in range(t)],MAX_N>>2,2,2)

def main():
  global f
  f = TestGen(1,problem='diamond', tests_path=os.path.join('..','tests'))    
  sample()
  small()
  big()
  f.close()

if __name__ == '__main__': main()
