import java.util.*;
import java.io.*;

public class lecture_sb_wa {

	final static String FNAME = "lecture";

	public Parser parser;
	public PrintWriter out;
	
	void open() throws IOException {
		Locale.setDefault( Locale.US );
		parser = new Parser( new BufferedReader( new FileReader( new File( FNAME + ".in" ) ) ) );
		out = new PrintWriter( new File( FNAME + ".out" ) );
	}

	void close() throws IOException {
		out.close();
	}

	long sum( long[] a, int l, int r ) {
		long t = 0;
		for ( int i = l; i < r; i ++ ) {
			t += a[i];
		}
		return t;
	}

	final static int MAX_N = 100000;
	final static int MAX_T = 300000;
	final static int MAX_V = 1000000000;

	void run() throws IOException {
		int[] a = parser.nextIntegersSeparatedBySpace( 2 );
		int n = a[0];
		int t = a[1];
		check( n >= 1 && n <= MAX_N && t >= 1 && t <= MAX_T,
				"Bad value of n or t: " + n + " " + t );
		long[][] v = new long[3][n + 1];
		int[] c = new int[3];
		for ( int i = 0; i < n; i ++ ) {
			a = parser.nextIntegersSeparatedBySpace( 2 );
			check( a[0] >= 1 && a[0] <= 3 && a[1] >= 0 && a[1] <= MAX_V,
					"Bad parameters of " + i + "-th theorem at line " + ( i + 1 ) );
			v[a[0] - 1][c[a[0] - 1] ++] = -a[1];
		}
		parser.checkEOF();
		for ( int i = 0; i < 3; i ++ ) {
			Arrays.sort( v[i], 0, c[i] );
		}
		for ( int i = 0; i < 3; i ++ ) {
			for ( int j = 0; j < c[i]; j ++ ) {
				v[i][j] = -v[i][j];
			}
		}
		long r = 0;
		int[] use = new int[] { 0, 0, Math.min( c[2], t / 3 ) };
		long cv = 0;
		for ( int i = 0; i <= use[2]; i ++ ) {
			cv += v[2][i];
		}
		for ( ; use[2] >= 0; use[2] -- ) {
			cv -= v[2][use[2]];
			while ( use[0] + use[1] * 2 + use[2] * 3 + 5 < t ) {
				if ( use[0] < c[0] && ( use[1] >= c[1] || v[0][use[0]] * 2 > v[1][use[1]] ) ) {
					cv += v[0][use[0]];
					use[0] ++;
				} else if ( use[1] < c[1] ) {
					cv += v[1][use[1]];
					use[1] ++;
				} else {
					break;
				}
			}
			int left = t - ( use[0] + use[1] * 2 + use[2] * 3 );
			for ( int i = 0; i <= 2; i ++ ) {
				if ( left >= i * 2 && use[1] + i <= c[1] ) {
					r = Math.max( r, cv + sum( v[1], use[1], use[1] + i ) +
							sum( v[0], use[0], Math.min( c[0], use[0] + left - 2 * i ) ) );
				}
			}
		}
		out.println( r );
	}	

	void check( boolean f, String msg ) {
		if ( ! f ) {
			out.close();
			throw new RuntimeException( msg );
		}
	}

	class Parser {
		BufferedReader in;
		int line;

		Parser( BufferedReader in ) {
			this.in = in;
			line = 0;
		}

		private void checkL( boolean f, String msg ) {
			check( f, "Line " + line + ": " + msg );
		}

		void checkEOF() throws IOException {
			check( in.readLine() == null, "EOF expected" );
		}

		String nextLine() throws IOException {
			line ++;
		    String s = in.readLine();
		    checkL( s != null, "Unexpected end of file" );
		    return s;
		}

		int[] nextIntegersSeparatedBySpace( int k ) throws IOException {
			String[] s = nextLine().split( " " );
			checkL( s.length == k, "Wrong format" );
			int[] r = new int[k];
			for ( int i = 0; i < k; i ++ ) {
				try {
					r[i] = new Integer( s[i] );
				} catch ( Exception e ) {
					checkL( false, "Not a number at position " + ( i + 1 ) );
				}
			}
			return r;
		}
	}
	
	public static void main( String[] args ) throws IOException {
		new Thread() {

			public void run() {
				try {
					lecture_sb_wa solution = new lecture_sb_wa();
					solution.open();
					solution.run();
					solution.close();
				} catch ( Exception e ) {
					throw new RuntimeException( e );
				}
			}
		}.start();
	}
}
