#include <cstdio>
#include <iostream>
#include <algorithm>
#include <functional>
#include <cassert>

using namespace std;

#define m 101000

int k[3], n, t, p1, p2, p3;
long long a[3][m], ans;

int len() { return 1 * p1 + 2 * p2 + 3 * p3; }
long long sum() { return a[0][p1] + a[1][p2] + a[2][p3]; }
void relax() { ans = max(ans, sum()); }

void solve( int t )
{
  int p30 = min(t / 3, k[2] - 1);
  int x1 = -1, x2 = -1, x3 = -1;
  long long xv = -1;
  for (p3 = max(0, p30 - 2); p3 <= p30; p3++)
  {
    p2 = k[1] - 1, p1 = 0;
    while (p1 < k[0])
    {
      while (p2 > 0 && len() > t)
        p2--;
      if (len() == t)
      {
        if (sum() > xv)
          x1 = p1, x2 = p2, x3 = p3, xv = sum();
      }
      p1++;
    }
  }
  if (xv == -1)
    return;
  p1 = x1, p2 = x2, p3 = x3;
  relax();
  int d1[] = {-1, 1, 3};
  int d2[] = { 2, 1, 0};
  while (p3 > 0)
  {
    p3--;
    int x1 = -1, x2 = -1;
    long long xv = -1;
    for (int i = 0; i < 3; i++)
    {
      p1 += d1[i], p2 += d2[i];
      if (0 <= p1 && p1 < k[0] && 0 <= p2 && p2 < k[1] && sum() > xv)
        x1 = p1, x2 = p2, xv = sum();
      p1 -= d1[i], p2 -= d2[i];
    }
    if (xv == -1)
      return;
    p1 = x1, p2 = x2;
    relax();
  }
}

void solve1()
{
  if (k[0] == 1)
  {
    p1 = 0, p2 = 0, p3 = k[2] - 1;
    while (p2 < k[1])
    {
      while (p3 > 0 && len() > t)
        p3--;
      if (len() <= t && sum() > ans)
        ans = sum();
      p2++;
    }
  }
  if ((k[0] - 1) * 1 + (k[1] - 1) * 2 + (k[2] - 1) * 3 <= t)
    ans = a[0][k[0] - 1] + a[1][k[1] - 1] + a[2][k[2] - 1];
}

int main()
{
  freopen("lecture.in", "r", stdin);
  freopen("lecture.out", "w", stdout);

  assert(scanf("%d%d", &n, &t) == 2);
  assert(1 <= n && n <= 100000);
  assert(1 <= t && t <= 300000);
  for (int i = 0; i < 3; i++)
    a[i][0] = 0, k[i] = 1;
  for (int i = 0; i < n; i++)
  {
    int q, p;
    assert(scanf("%d%d", &q, &p) == 2);
    assert(1 <= q && q <= 3);
    assert(0 <= p && p <= 1000000000);
    q--;
    a[q][k[q]++] = p;
  }
  for (int i = 0; i < 3; i++)
    sort(a[i] + 1, a[i] + k[i], greater<long long>());
  for (int i = 0; i < 3; i++)
    for (int j = 1; j < k[i]; j++)
      a[i][j] += a[i][j - 1];
  ans = 0;
  solve1();
  for (int tt = 0; tt < 3; tt++)
    solve(max(0, t - tt));

  cout << ans << endl;

  return 0;
}
