#!/usr/bin/env python2

from amtest import *

MAXN  = pow(10,5)
MAXT  = 3 * MAXN
MAXAI = pow(10,9)

def sum_from_one_to_n(n): return (n * (n+1)) >> 1

def pt(z,ans=None,desc=''):
  #if ans==None: return
  T,a = z
  N = len(a)
  assert(1 <= N <= MAXN)
  assert(1 <= T <= MAXT)
  f.begin_test(desc + (' N = %d T = %d' % (N,T)) )
  f.write('%d %d\n' % (N,T))
  for t,v in a:
    f.write("%d %d\n" % (t,v))
    assert(1 <= t <= 3)
    assert(0 <= v <= MAXAI)
  f.end_test()
  if ans!=None: f.make_answer(str(ans))

def rt(n, mint=1, maxai = MAXAI):
  assert(1 <= mint <= 3)
  assert(0 < maxai <= MAXAI)
  a = []
  t = 0
  for i in range(n):
    j = random.randint(mint,3)
    t += j
    a.append( (j, random.randint(0,maxai)) )
  t = random.randint(1,min(MAXT, t + (t // 20)))
  pt( (t, a), desc='rt(n=%d mint=%d maxai=%d)'%(n,mint,maxai) )

def rt2(n, p1, p2, p3):
  """
  p1 / (p1 + p2 + p3) - probability occuring 1-minute theorem
  p2 / (p1 + p2 + p3) - probability occuring 2-minute theorem
  p3 / (p1 + p2 + p3) - probability occuring 3-minute theorem
  """
  z = ([1] * p1) + ([2] * p2) + ([3] * p3)
  a = []
  t = 0
  for i in range(n):
    j = random.choice(z)
    t += j
    a.append( (j, random.randint(0,MAXAI)) )
  t = random.randint(1, min(MAXT, t + (t // 20)))
  pt( (t, a), desc='rt2(%d,%d,%d,%d)'%(n,p1,p2,p3) )

def sample():
  pt( (3, [(1,3), (2,10), (2,14)]), 17)
  pt( (4, [(2,5), (2,10), (3,14)]), 15)

def small():
  pt( (1 , [(1,0)]) , 0)
  pt( (1 , [(2,1)]) , 0)
  pt( (2 , [(2,1),(3,10)] ), 1)
  pt( (3 , [(2,10),(3,15),(2,10)]), 15)
  pt( (4 , [(2,10),(3,15),(2,10)]), 20)
  pt( (3 , [(1,1),(1,2),(1,3),(3,5)]) , 6)       #1+1+1 = 3
  pt( (6 , [(2,1),(2,2),(2,3),(3,2),(3,3)]) , 6) #2+2+2 = 6
  pt( (6 , [(2,1),(2,2),(2,1),(3,2),(3,3)]) , 5) #3+3   = 6
  pt( (7 , [(2,1),(2,1),(3,10),(3,10)]) , 20)
  pt( (4,  [(2,1),(2,1),(1,2),(3,1)]) , 3)       #2+2=3+1

def random_tests():
  ncases = 20
  for i in range(ncases):
    rt(100 + ((MAXN - 100) // ncases) * i, maxai = 1000 + ((MAXAI - 1000) // ncases) * i )

def big():
  pt( (300000, [(3,MAXAI)] * MAXN), MAXN * MAXAI)
  pt( (299999, [(3,MAXAI)] * MAXN), (MAXN-1) * MAXAI)
  x = (MAXAI//3)*2
  pt( (299999, [(3,MAXAI)] * (MAXN-1) + [(2, x)]), (MAXN-1) * MAXAI + x)

  pt( (10000,  [(1,i) for i in range(1,MAXN+1)]), sum_from_one_to_n(MAXN) - sum_from_one_to_n(MAXN-10000) )
  a = anti_pascal_qsort_permutation(MAXN)
  pt( (10000,  [(1,i) for i in a]), sum_from_one_to_n(MAXN) - sum_from_one_to_n(MAXN-10000) )
  pt( (1, [(random.randint(2,3),i) for i in a]), 0)

  for t in range(10): rt(MAXN)
  rt(MAXN, mint=2)
  rt(MAXN, mint=3)
  rt2(MAXN, 1, 0, 0)
  rt2(MAXN, 0, 1, 0)
  for t in range(3): rt2(MAXN, 0, 1, 1000)
  rt2(MAXN, 1, 10, 100)
  rt2(MAXN, 1, 2, 3)
  for t in range(10): rt2(MAXN, random.randint(1,1000), random.randint(1,1000), random.randint(1,1000))

  #lecture_yp.cpp (rev:4049) outputs zero again on these tests:
  pt( (65, [(2, 157498645), (3, 564782254), (3, 868812320), (2, 703852257), (3, 222834340), (1, 633565771), (2, 423828948), (3, 603633653), (2, 508944764), (3, 134098578), (3, 644974227), (3, 659546745), (3, 832397825), (3, 964881507), (1, 274767236), (3, 458304754), (1, 829111801), (2, 408983739), (3, 642164910), (1, 561387910), (1, 536902684), (1, 470333295), (2, 661926197), (1, 960747002), (1, 708911899), (2, 491851691), (2, 632295171), (1, 16462506), (2, 202234190), (2, 186392857)]) )
  pt( (104, [(1, 672107081), (3, 552608129), (3, 684538224), (2, 914566333), (1, 730055751), (2, 120247537), (1, 761690130), (1, 247087090), (3, 587568086), (3, 759820265), (3, 927096084), (3, 319911006), (2, 738940628), (1, 823613402), (2, 647667650), (2, 481120371), (1, 784543339), (3, 241813407), (1, 864295385), (3, 457091923), (1, 249292659), (1, 618181716), (3, 415029595), (1, 484381162), (2, 536849579), (2, 894937320), (1, 616980736), (3, 690820390), (3, 98790450), (2, 839633954), (3, 993992499), (3, 60291102), (1, 518305834), (2, 445632369), (2, 303217260), (2, 27956069), (1, 988552630), (1, 192522104), (2, 144710561), (2, 67730440), (2, 15280286), (3, 314358024), (1, 892013315), (1, 655714362), (3, 887327448), (3, 95783030), (1, 524820119), (3, 573974160), (2, 595756328), (2, 822203805)]) )

def main():
  global f
  f = TestGen(1,problem='lecture', tests_path=os.path.join('..','tests'))
  sample()
  small()
  random_tests()
  big()
  f.close()

if __name__ == '__main__': main()
