#include <testlib.h>

const int n = 4;
const double eps = 1.1e-6;

double vp ( double x0, double y0, double x1, double y1, double x2, double y2 ) {
  return ((x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0)) * 0.5;
}

int main ( int argc, char **argv ) {
  registerTestlibCmd (argc, argv);

  double xj[n + 1], xc[n + 1], yj[n + 1], yc[n + 1];

  for (int i = 0; i < n; i++) {
    double jury = ans.readDouble ();
    double cont = ouf.readDouble ();
    if (fabs (jury - cont) > eps)
      quitf (_wa, "Required: %.10lf, got: %.10lf", jury, cont);
    xj[i] = jury;
    xc[i] = cont;
    jury = ans.readDouble ();
    cont = ouf.readDouble ();
    if (fabs (jury - cont) > eps)
      quitf (_wa, "Required: %.10lf, got: %.10lf", jury, cont);
    yj[i] = jury;
    yc[i] = cont;
  }
  xj[n] = xj[0], yj[n] = yj[0];
  xc[n] = xc[0], yc[n] = yc[0];
  double sj = 0, sc = 0;
  for (int i = 0; i < n; i++) {
    sj += vp (0.0, 0.0, xj[i + 1], yj[i + 1], xj[i], yj[i]);
    sc += vp (0.0, 0.0, xc[i + 1], yc[i + 1], xc[i], yc[i]);
  }

  if (abs (sj - sc) > eps)
    quitf (_wa, "Area: required %.10lf, got %.10lf", sj, sc);
  quitf (_ok, "Answer: %.10lf", sc);
}

