{$I-,Q-,R-}
{$I trans.inc}
program macro;
uses testlib, SysUtils;
type Integer = Longint;
const MaxN = 4; eps = 1.1e-6;
{Set eps to 1.1e-5 to know the exact maximal difference}
var xj, yj, xc, yc: array [0..MaxN] of Extended;
 jury, cont, sj, sc, curdiff, maxdiff: Extended;
 i, num, best: Integer;

function vp (x0, y0, x1, y1, x2, y2: Extended): Extended;
begin
  vp := ((x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0)) * 0.5;
end;

BEGIN
  maxdiff := 0.0;
  best := 0;
  num := 0;
  while NOT ans.seekeof do begin
    inc (num);
    for i := 1 to MaxN do begin
      jury := ans.readreal;
      cont := ouf.readreal;
      curdiff := abs (jury - cont);
      if maxdiff < curdiff then
        maxdiff := curdiff;
      if abs (jury - cont) > eps then
        quit (_wa, 'Required: ' + r2s (jury) + ', got: ' + r2s (cont));
      xj[i] := jury;
      xc[i] := cont;
      jury := ans.readreal;
      cont := ouf.readreal;
      curdiff := abs (jury - cont);
      if maxdiff < curdiff then
        maxdiff := curdiff;
      if abs (jury - cont) > eps then
        quit (_wa, 'Required: ' + r2s (jury) + ', got: ' + r2s (cont));
      yj[i] := jury;
      yc[i] := cont;
    end;
    xj[0] := xj[MaxN]; yj[0] := yj[MaxN];
    xc[0] := xc[MaxN]; yc[0] := yc[MaxN];
    sj := 0.0; sc := 0.0;
    for i := 1 to MaxN do begin
      sj := sj + vp (0.0, 0.0, xj[i], yj[i], xj[i - 1], yj[i - 1]);
      sc := sc + vp (0.0, 0.0, xc[i], yc[i], xc[i - 1], yc[i - 1]);
    end;
    curdiff := abs (sj - sc);
    if maxdiff < curdiff then begin
      maxdiff := curdiff;
      best := num;
    end;
    if abs (sj - sc) > eps then
      quit (_wa, 'Area: required ' + r2s (sj) + ', got ' + r2s (sc));
  end;
  if not ouf.seekeof then
    quit (_pe, 'EOF expected');
  quit (_ok, format ('Maximal difference: %.12f on test %d.',
   [maxdiff, best]));
END.
