@echo off
call include.cmd
if exist tests (
 pushd tests
 set RELPATH=..
) else (
 set RELPATH=.
)
echo Compiling solution and checker...
if exist %RELPATH%\%SOL%.cpp (
 g++ -O2 -Wall -Wl,--stack=67108864 %RELPATH%\%SOL%.cpp -o %SOL%.exe
) else if exist %RELPATH%\%SOL%.c (
 gcc -x c -O2 -Wall -Wl,--stack=67108864 %RELPATH%\%SOL%.c -o %SOL%.exe
)
if exist %RELPATH%\check.cpp (
 g++ -O2 -Wall -Wl,--stack=67108864 %RELPATH%\check.cpp -o %RELPATH%\check.exe
) else if exist %RELPATH%\check.dpr (
 dcc32 -cc %RELPATH%\check.dpr -e%RELPATH% -I%TESTLIB% -U%TESTLIB%
) else (
 echo Can not compile checker!
)
echo Generating tests...
if exist %TASK%.in (
 erase %TASK%.in
)
if exist small.in (
 copy small.in %TASK%.in
)
if exist gen.py (
 gen.py >>%TASK%.in
)
echo Processing solution %SOL% on tests...
if exist %SOL%.exe (
 %SOL%
) else if exist %SOL%.py (
 %SOL%.py
)
echo Splitting tests...
%RELPATH%\splittests.py
if %RELPATH%==.. (
 popd
)
echo Done!
