#include <cstdio>
#include <cstring>

#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define maxn 100010
#define maxit (1 << 17)
#define maxk 110

int n, k;
int l[maxn], r[maxn], p[maxn];
int it1[maxit + maxn], it2[maxit + maxn];
int d[2][maxn];

bool rless( const int &a, const int &b )
{
  return r[a] < r[b];
}

void itbuild( int *it )
{
  memset(it, 0, sizeof(it[0]) * maxit);
  for (int i = maxn + maxit - 1; i > 0; i--)
    it[i / 2] = max(it[i / 2], it[i]);
}

int itget( int *it, int l, int r )
{
  if (l > r)
    return 0;
  l += maxit, r += maxit;
  int res = max(it[l], it[r]);
  while (l / 2 < r / 2)
  {
    if ((l & 1) == 0)
      res = max(res, it[l ^ 1]);
    if ((r & 1) == 1)
      res = max(res, it[r ^ 1]);
    l >>= 1, r >>= 1;
  }
  return res;
}

int main()
{
  freopen("timetable.in", "r", stdin);
  freopen("timetable.out", "w", stdout);

  scanf("%d%d", &n, &k);
  forn (i, n)
    scanf("%d%d", &l[i], &r[i]), p[i] = i;
  sort(p, p + n, rless);

  int totalRight = r[p[n - 1]];
  memset(d, 0, sizeof(d));
  int t = 0;
  forn (i, k)
  {
    forn (j, n)
      it1[maxit + j] = d[t][j], it2[maxit + j] = d[t][j] + totalRight - r[p[j]];
    itbuild(it1);
    itbuild(it2);
    forn (j, n)
    {
      int left = 0, right = j;
      while (left < right)
      {
        int ave = (left + right) / 2;
        if (r[p[ave]] >= l[p[j]])
          right = ave;
        else
          left = ave + 1;
      }
      d[1 ^ t][j] = max(d[t][j], max(itget(it1, 0, left - 1) + r[p[j]] - l[p[j]], itget(it2, left, j) - (totalRight - r[p[j]])));
    }
    t = 1 ^ t;
  }

  int ans = 0;
  forn (i, n)
    ans = max(ans, d[t][i]);
  printf("%d\n", ans);

  return 0;
}

