#include <cstdio>
#include <algorithm>
#include <cassert>

using namespace std;

struct seg
{
  int l, r;
};

bool operator < ( seg a, seg b )
{
  if (a.l == b.l)
    return a.r > b.r;
  return a.l < b.l;
}

void relax( int &a, int b )
{
  a = max(a, b);
}

#define m 100100
#define inf (int)2e9

int n, k, q, ne[m], fi[m][2], fo[m][2];
seg s[m], t[m];

int main()
{
  freopen("timetable.in", "r", stdin);
  freopen("timetable.out", "w", stdout);

  // read data
  assert(scanf("%d%d", &n, &k) == 2);
  assert(1 <= n && n <= 100000);
  assert(0 <= k && k <= 100);
  for (int i = 0; i < n; i++)
  {
    assert(scanf("%d%d", &s[i].l, &s[i].r));
    assert(0 <= s[i].l && s[i].l <= s[i].r && s[i].r <= 1000000000);
  }
  // prepare data
  sort(s, s + n);
  q = 0;
  for (int i = 0, j = 0; i < n; i = j)
  {
    t[q++] = s[i];
    while (j < n && s[j].r <= s[i].r)
      j++;
  }
  for (int i = 0, j = 0; i < q; i++)
  {
    while (j < q && t[j].l < t[i].r)
      j++;
    ne[i] = j;
  }
//  for (int i = 0; i < q; i++)
//    fprintf(stderr, "%d: (%d %d) ne=%d\n", i, t[i].l, t[i].r, ne[i]);
  // solve
  for (int i = 0; i <= q; i++)
    fo[i][0] = fi[i][0] = -inf;
  fo[0][0] = 0;
  int ans = 0;
  for (int j = 0, c = 0; j <= k; j++, c = 1 - c)
  {
    for (int i = 0; i <= q; i++)
      fo[i][1 - c] = fi[i][1 - c] = -inf;
    for (int i = 0; i < q; i++)
    {
      if (fo[i][c] != -inf)
      {
//        fprintf(stderr, "fo[%d][%d]=%d\n", i, j, fo[i][c]);
        relax(fo[i + 1][c], fo[i][c]);
        relax(fi[i][1 - c], fo[i][c] - t[i].l);
      }
      if (fi[i][c] != -inf)
      {
//        fprintf(stderr, "fi[%d][%d]=%d\n", i, j, fi[i][c]);
        if (ne[i] != i + 1)
          relax(fi[ne[i] - 1][1 - c], fi[i][c]);
        relax(fo[ne[i]][c], fi[i][c] + t[i].r);
      }
    }
//    fprintf(stderr, "ans >?= %d\n", fo[q][c]);
    relax(ans, fo[q][c]);
  }
  printf("%d\n", ans);

  return 0;
}
