#include <cstdio>
#include <algorithm>
#include <cassert>

using namespace std;

struct seg
{
  int l, r;
};

bool operator < ( seg a, seg b )
{
  if (a.l == b.l)
    return a.r > b.r;
  return a.l < b.l;
}

void relax( int &a, int b )
{
  a = max(a, b);
}

#define m 100100
#define mk 105

int n, k, q, ne[m], fi[m][mk], fo[m][mk];
seg s[m], t[m];

int main()
{
  freopen("timetable.in", "r", stdin);
  freopen("timetable.out", "w", stdout);

  // read data
  assert(scanf("%d%d", &n, &k) == 2);
  assert(1 <= n && n <= 100000);
  assert(0 <= k && k <= 100);
  for (int i = 0; i < n; i++)
  {
    assert(scanf("%d%d", &s[i].l, &s[i].r));
    assert(0 <= s[i].l && s[i].l <= s[i].r && s[i].r <= 1000000000);
  }
  // prepare data
  sort(s, s + n);
  q = 0;
  for (int i = 0, j = 0; i < n; i = j)
  {
    t[q++] = s[i];
    while (j < n && s[j].r <= s[i].r)
      j++;
  }
  for (int i = 0, j = 0; i < q; i++)
  {
    while (j < q && t[j].l < t[i].r)
      j++;
    ne[i] = j;
  }
  // solve
  memset(fi, -1, sizeof(fi));
  memset(fo, -1, sizeof(fo));
  fo[0][0] = 0;
  for (int i = 0; i < q; i++)
    for (int j = 0; j <= k; j++)
    {
      if (fo[i][j] != -1)
      {
        relax(fi[i + 1][j + 1], fo[i][j] + t[i].r - t[i].l);
        relax(fo[i + 1][j], fo[i][j]);
      }
      if (fi[i][j] != -1)
      {
        relax(fi[i + 1][j + 1], fi[i][j] + t[i].r - max(t[i].l, i ? t[i - 1].r : 0));
        relax(fo[ne[i]][j], fi[i][j]);
      }
    }
  int ans = 0;
  for (int i = 0; i <= k; i++)
    relax(ans, fo[q][i]), relax(ans, fi[q][i]);
  printf("%d\n", ans);

  return 0;
}
