#include <cstdio>
#include <algorithm>
#include <cassert>

using namespace std;

struct seg
{
  int l, r;
};

bool operator < ( seg a, seg b )
{
  if (a.l == b.l)
    return a.r > b.r;
  return a.l < b.l;
}

void relax( int &a, int b )
{
  a = max(a, b);
}

#define m 100100

int n, k, a[m], ans = 0;
seg s[m], t[m];

void go( int i, int nu )
{
  if (nu == k || i == n)
  {
    for (int i = 0; i < k; i++)
      t[i] = s[a[i]];
    sort(t, t + k);
    int cur = 0;
    for (int i = 0, j = 0; i < k; i = j)
    {
      int r = t[i].r;
      while (j < k && t[j].l <= r)
        r = max(r, t[j++].r);
      cur += r - t[i].l;
    }
    relax(ans, cur);
  }
  else
  {
    go(i + 1, nu);
    a[nu] = i;
    go(i + 1, nu + 1);
  }
}

int main()
{
  freopen("timetable.in", "r", stdin);
  freopen("timetable.out", "w", stdout);

  // read data
  assert(scanf("%d%d", &n, &k) == 2);
  assert(1 <= n && n <= 100000);
  assert(0 <= k && k <= 100);
  for (int i = 0; i < n; i++)
  {
    assert(scanf("%d%d", &s[i].l, &s[i].r));
    assert(0 <= s[i].l && s[i].l <= s[i].r && s[i].r <= 1000000000);
  }
  go(0, 0);
  printf("%d\n", ans);

  return 0;
}
