#!/usr/bin/env python2

from amtest import *

MAX_N = 10000
MAX_M = 100000
MAX_PAGES = 10000

def pt(z,desc=''):
  p,w = z
  N = len(p)
  M = len(w)
  assert(1 <= N <= MAX_N)
  assert(1 <= M <= MAX_M)

  assert(min(p) > 0)
  assert(max(p) <= MAX_PAGES)

  f.begin_test(desc)
  f.write('%d %d\n' % (N,M))
  f.write(' '.join(list(map(str,p))) + '\n')
  for i in w:
    assert(len(i)==4)
    assert(1 <= i[1] <= p[i[0]-1])
    assert(1 <= i[3] <= p[i[2]-1])
    f.write(' '.join(list(map(str,i))) + '\n')
  f.end_test()

def rp(r):
  book = random.randint(1,len(r))
  page = random.randint(1,r[book-1])
  return (book,page)

def rt(n,m):
  r = [random.randint(1,MAX_PAGES) for t in range(n)]
  w = []
  for t in range(m):
    u1,v1 = rp(r)
    u2,v2 = rp(r)
    w.append( (u1,v1,u2,v2) )
  pt( (r,w),'rt(%d,%d)' % (n,m) )

def sample():
  pt( ([1,1,1],[(1,1,3,1),(2,1,2,1)]))

def small():
  pt( ([1], [(1,1,1,1)] ) )
  pt( ([2,2],[(1,1,2,2)]) )
  pt( ([10], [ (1,1,1,1),(1,10,1,10) ] ) )
  pt( ([10], [ (1,1,1,i) for i in range(1,11)] ) )
  pt( ([10], [ (1,1+2*i,1,2+2*i) for i in range(5) ] ) )
  pt( ([10], [ (1,1+i,1,2+i) for i in range(9) ] ) )
  pt( ([100],[ (1,1+i,1,2+i) for i in range(9) ] ) )
  pt( ([100],[ (1,92+i,1,91+i) for i in range(9) ] ) )


def big_hand_test(npages_in_book, r1, r2, shuffle=True):
  m = npages_in_book
  #print '%d %d' % (len(r1),len(r2) )
  assert(len(r1) == len(r2))
  r = [npages_in_book] * MAX_N
  w = [ (1+(r1[i]//m),m-(r1[i]%m),1+(r2[i]//m),m-(r2[i]%m) ) for i in range(len(r1))]
  if shuffle: random.shuffle(w)
  pt( (r,w) )

def big():
  pt( ([MAX_PAGES] * MAX_N, [(1,MAX_PAGES,MAX_N,1)] * MAX_M) )
  pt( ([MAX_PAGES] * MAX_N, [(MAX_N,MAX_PAGES,MAX_N,MAX_PAGES)] * MAX_M) )

  big_hand_test(10, range(0,MAX_M), range( 10 * MAX_N - 1, 10 * MAX_N-1 - MAX_M,-1) )
  big_hand_test(20, range(0,2*MAX_M,2),range(1,1+2*MAX_M,2))
  #max diffent values in sorting
  big_hand_test(20, range(0,MAX_M), range(20*MAX_N-1,20*MAX_N-1-MAX_M,-1) )

  p = anti_pascal_qsort_permutation(2*MAX_M)
  p1,p2 = [],[]
  k = 10000 // 20
  for i in range(MAX_M):
    p1.append((p[2*i]-1) * k )
    p2.append((p[2*i+1]-1) * k )
  big_hand_test(10000, p1, p2 , shuffle=False)

def small_random_tests():
  nt = 30
  for nm in range(20,100000, (100000 - 20) // nt):
    rt(min(10000,nm),nm)

def big_random_tests():
  for t in range(20): rt(MAX_N,MAX_M)

def main():
  global f
  f = TestGen(1,problem='worms', tests_path=os.path.join('..','tests'))
  sample()
  small()
  small_random_tests()
  big()
  big_random_tests()

  f.close()

if __name__ == '__main__': main()
