/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com)
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back

const int N = 5e5;

int q, n, a, b, T, l[N], r[N];
vector<int> c[N];

inline int readChar();
template <class T = int> inline T readInt(); 
template <class T> inline void writeInt( T x );
inline void writeChar( int x ); 
inline void flush();

void dfs( int v, int pr = -1 ) {
	l[v] = T++;
	for (int x : c[v])
		if (x != pr)
			dfs(x, v);
	r[v] = T;
}

struct Fenwick {
	int n, sum[N];

	void add( int y ) {
		for (int x = y; x < N; x |= x + 1)
			sum[x] ^= 1;
	}
	int get( int x ) {
		int r = 0;
		for (; x >= 0; x &= x + 1, x--) 
			r ^= sum[x]; 
		return r;
	}
	int get( int l, int r ) {
		return get(r) ^ get(l - 1);
	}
} f;

int main() {
	n = readInt();
	forn(i, n - 1) {
		a = readInt() - 1;
		b = readInt() - 1;
		c[a].pb(b), c[b].pb(a);
	}
	dfs(0);
	q = readInt();
	while (q--) {			 
		char ch = readChar();
		a = readInt() - 1;
		b = readInt() - 1;
		if (ch == 'U')
			f.add(l[a]), f.add(l[b]);
		else {
			a = (l[a] < l[b] ? b : a);
			writeInt((f.get(l[a], r[a] - 1) ^ 1)), writeChar(' ');
		}
	}
	flush();
	return 0;
}

/** Read */

static const int buf_size = 4096;

inline int getChar() {
	static char buf[buf_size];
	static int len = 0, pos = 0;
	if (pos == len)
		pos = 0, len = fread(buf, 1, buf_size, stdin);
	if (pos == len)
		return -1;
	return buf[pos++];
}

inline int readChar() {
	int c = getChar();
	while (c <= 32)
		c = getChar();
	return c;
}

template <class T>
inline T readInt() {
	int s = 1, c = readChar();
	T x = 0;
	if (c == '-')
		s = -1, c = getChar();
	while ('0' <= c && c <= '9')
		x = x * 10 + c - '0', c = getChar();
	return s == 1 ? x : -x;
}

/** Write */

static int write_pos = 0;
static char write_buf[buf_size];

inline void writeChar( int x ) {
	if (write_pos == buf_size)
		fwrite(write_buf, 1, buf_size, stdout), write_pos = 0;
	write_buf[write_pos++] = x;
}

inline void flush() {
	if (write_pos)
		fwrite(write_buf, 1, write_pos, stdout), write_pos = 0;
}

template <class T> 
inline void writeInt( T x ) {
	if (x < 0)
		writeChar('-'), x = -x;

	char s[24];
	int n = 0;
	while (x || !n)
		s[n++] = '0' + x % 10, x /= 10;
	while (n--)
		writeChar(s[n]);
}
