#!/usr/bin/env python3

import math
import sys
import burunduk3_bayes

files = sys.argv[1:]
n = len (files)
m = [{} for i in range (n)]
total = [0 for i in range (n)]
for (i, counts_name) in enumerate (files):
    total[i] = 0
    with open (counts_name, 'rt') as counts_file:
        for line in counts_file.readlines ():
            c, w = line.split ()
            c = int (c)
            # c = math.sqrt (c)
            m[i][w] = c
            total[i] += c

    # print ('m[w=%s] = %d' % ('You', m['You']))
    for w in m[i].keys ():
        m[i][w] = math.log (m[i][w] / total[i])
    # avg = math.log (total / len (m[i]))
    # print ('m[w=%s] = %.10f' % ('You', m['You']))
for x in m:
    for w in x:
        for i in range (n):
            if w not in m[i]:
                m[i][w] = math.log (0.01 / total[i])

value = [0 for i in range (n)]
words = []
for l in sys.stdin.readlines ():
    for w in map (burunduk3_bayes.word_clear, l.split ()):
        ok = True
        for x in m:
            if w not in x:
                ok = False
        if not ok:
            # print ('  word ignored: %s' % w)
            continue
        words.append (w)
words = list ( set (words))
for w in words:
    for i in range (n):
        value[i] += m[i][w]
    # print ('add : %s ; values : %s # %s' % (' '.join (['%10.5f' % m[i][w] for i in range (n)]), ' '.join (['%10.5f' % x for x in value]), w))
    # print ('  value += %17.10lf -> %17.10lf   w=%s' % (m[w], value, w))

result = sorted (enumerate (value), key=lambda x: -x[1])
print ("%s value = %.20lf, next = %.20lf, diff = %.20lf" % (files[result[0][0]].split ('.') [0], result[0][1], result[1][1], result[0][1] - result[1][1]))
# value = value + count * avg
# for x in value:
#    print ("%.20f" % x)
# print ("%.20f" % math.exp (value))

