#!/bin/bash

count0=100
count1=50

# count0=200
# count1=200

echo "collect stats"
total0="`ls beatles/* | wc -l`"
total1="`ls rolling_stones/* | wc -l`"

ls beatles/* | shuf > beatles.shuf
cat beatles.shuf | head -n "$count0" | xargs -d '\n' cat | ./word_count.py > beatles.count
ls rolling_stones/* | shuf > rolling_stones.shuf
cat rolling_stones.shuf | head -n "$count1" | xargs -d '\n' cat | ./word_count.py > rolling_stones.count
echo "  beatles: used $count0 files of $total0"
echo "  rolling stones: used $count1 files of $total1"

echo "check data (new)"
while read x; do
    echo "`dirname "$x"` file: $x"
    ./song_check.py {beatles,rolling_stones}.count < "$x"
done < <(tail -n "+$(($count0 + 1))" beatles.shuf; tail -n "+$(($count1 + 1))" rolling_stones.shuf) > result.new
echo "check data (old)"
while read x; do
    echo "`dirname "$x"` file: $x"
    ./song_check.py {beatles,rolling_stones}.count < "$x"
done < <(head -n "$count0" beatles.shuf; head -n "$count1" rolling_stones.shuf) > result.old

echo "judge"

count_ok=0
count_fail=0
while read ja line; do
    read pa line
    if [ "$pa" == "$ja" ]; then
        echo "OK $line"
        count_ok=$(($count_ok + 1))
    else
        echo "FAIL $line"
        count_fail=$(($count_fail + 1))
    fi
done < result.new > failures

echo "=== new ==="
echo "ok: $count_ok"
echo "fail: $count_fail"

count_ok=0
count_fail=0
while read ja line; do
    read pa line
    if [ "$pa" == "$ja" ]; then
        count_ok=$(($count_ok + 1))
    else
        count_fail=$(($count_fail + 1))
    fi
done < result.old

echo "=== old ==="
echo "ok: $count_ok"
echo "fail: $count_fail"

ls -l result

